package com.example.fuzzControll.controller.dataController;


import com.example.fuzzControll.domain.bo.FuzzParams;
import com.example.fuzzControll.domain.vo.AjaxResult;
import com.example.fuzzControll.domain.vo.KittyResult;
import com.example.fuzzControll.service.FuzzParamsService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Date;
import java.util.List;

@RestController
@RequestMapping("/fuzzParams")
@Slf4j
public class FuzzParamsController {
    @Autowired
    FuzzParamsService fuzzParamsService;

    /**
     * 获取参数列表
     */
    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public AjaxResult list() {
        List<FuzzParams> results;
        try {
            results = fuzzParamsService.getFuzzParamsList();
        } catch (Exception e) {
            log.error("Get params of fuzz error:{}", e.getMessage());
            return AjaxResult.error();
        }
        return AjaxResult.success(results);
    }

    /**
     * 跟据任务id获取参数
     */
    @RequestMapping(value = "/getParam/{missionId}", method = RequestMethod.GET)
    public AjaxResult getById(@PathVariable("missionId") int missionId) {
        FuzzParams result;
        try {
            result = fuzzParamsService.getFuzzParamById(missionId);
        } catch (Exception e) {
            log.error("Get params of fuzz with id error:{}", e.getMessage());
            return AjaxResult.error();
        }
        return AjaxResult.success(result);
    }

    /**
     * 跟据id修改参数
     */
    @RequestMapping(value = "/editParam", method = RequestMethod.POST)
    public AjaxResult editById(@RequestBody FuzzParams fuzzParams) {
        boolean flag = false;
        try {
            fuzzParams.setEditTime(new Date());
            flag = fuzzParamsService.editFuzzParams(fuzzParams);
        } catch (Exception e) {
            log.error("Edit params  with id error:{}", e.getMessage());
            return AjaxResult.error();
        }
        return AjaxResult.success(flag);
    }

}
