package com.example.fuzzControll.tools.system;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.concurrent.ConcurrentHashMap;

/**
 * 系统运行时，全局参数
 */
public class SystemRunningParams {
    /**
     * 系统全局测试时间参数
     */
    public static ConcurrentHashMap<String, ConcurrentHashMap<String, Long>> testTimeMessage = new ConcurrentHashMap<>();
    /**
     * 多线程异常控制
     */
    public static ConcurrentHashMap<Thread, String> ThreadState = new ConcurrentHashMap<>();
    /**
     * 系统中运行的aflnet当前missionId
     */
    public static int aflnetMissionId = 0;
    /**
     * 系统中运行的kitty当前missionId
     */
    public static int kittyMissionId = 0;
    /**
     * aflnet运行时数据
     */
    public static ConcurrentHashMap<String, String> aflnetData = new ConcurrentHashMap<>();//当前aflnet任务的数据
    /**
     * kitty运行时数据
     */
    public static ConcurrentHashMap<String, String> kittyData = new ConcurrentHashMap<>();//当前kitty任务的数据

    /**
     * 测试进度map
     */
    public static LinkedHashMap<String, String> TestProgressMap = new LinkedHashMap<>();

    /**
     * 异常重放结果数据
     */
    public static List<String> ReplayResults = new ArrayList<>();
    /**
     * 异常重放启动服务器信息数据
     */
    public static List<String> ReplayRunServerMessage = new ArrayList<>();
    public static void init() {
        /*初始化aflnet和kitty时间参数*/
        testTimeMessage.put("aflnet", new ConcurrentHashMap<>());
        testTimeMessage.put("kitty", new ConcurrentHashMap<>());
        /*初始化两个测试的起止时间*/
        testTimeMessage.get("aflnet").put("start", 0L);
        testTimeMessage.get("aflnet").put("end", 0L);
        testTimeMessage.get("kitty").put("start", 0L);
        testTimeMessage.get("kitty").put("end", 0L);
        /*初始化测试进度map*/
        TestProgressMapInit();
    }

    /**
     * 测试进度初始化
     */
    private static void TestProgressMapInit() {
        TestProgressMap.put("系统已运行时间", "");
        TestProgressMap.put("当前正在执行的变异阶段", "");
        TestProgressMap.put("总执行次数", "");
        TestProgressMap.put("平均执行速度", "");
        TestProgressMap.put("总的崩溃数量", "");
        TestProgressMap.put("总的超时数量", "");
        TestProgressMap.put("发现的唯一崩溃的总数", "");
        TestProgressMap.put("发现的唯一挂起总数", "");
        TestProgressMap.put("距上次发现新路径过去多少时间", "");
        TestProgressMap.put("据上次发现唯一崩溃过去多少时间", "");
        TestProgressMap.put("距上次发现唯一挂起过去多少时间", "");
        TestProgressMap.put("队列循环次数", "");
        TestProgressMap.put("队列测试用例总数", "");
        TestProgressMap.put("队列中待fuzz的用例数量", "");
        TestProgressMap.put("添加到队列中的用例数量", "");
        TestProgressMap.put("当前正在fuzz队列的第几个测试用例/测试进度", "");
        TestProgressMap.put("放弃的用例数量/占总用例的比率", "");
        TestProgressMap.put("当前执行次数/该阶段需要执行的次数（执行进度）", "");

    }
}
