package com.example.fuzzbackendmaster.controller;

import com.example.fuzzbackendmaster.pojo.vo.AjaxResult;
import com.example.fuzzbackendmaster.service.FuzzIntegrationFileApi;
import com.example.fuzzbackendmaster.service.FuzzLogService;
import com.example.fuzzbackendmaster.service.KittyAgentService;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.rmi.RemoteException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.EmptyStackException;

@RestController
@RequestMapping("/agent")
@Slf4j
public class KittyAgentController {
    @Autowired
    FuzzIntegrationFileApi fuzzIntegrationFileApi;
    @Autowired
    KittyAgentService kittyAgentService;

    /**
     * 启动网络代理
     *
     */
    @RequestMapping(value = "/kittyNetworkAgent", method = RequestMethod.GET)
    public AjaxResult startNetworkAgent(@RequestParam String networkCard, @RequestParam String monitorName) {
        try {
            return fuzzIntegrationFileApi.startNetworkAgent(networkCard, monitorName);
        } catch (Exception e) {
            log.error("Start network agent error:{}", e.getMessage());
            return AjaxResult.error();
        }
    }
    /**
     * 启动ssh代理
     */
    @RequestMapping(value = "/kittySshAgent", method = RequestMethod.GET)
    public AjaxResult startSshAgent(@RequestParam String MonitorName, @RequestParam String SshUserName,
                                    @RequestParam String SshPassword, @RequestParam String SshIp,
                                    @RequestParam String SshPort, @RequestParam String Command) {
        try {
            return fuzzIntegrationFileApi.startSshAgent(MonitorName,SshUserName,SshPassword,SshIp,SshPort,Command);
        } catch (Exception e) {
            log.error("Start network agent error:{}", e.getMessage());
            return AjaxResult.error();
        }
    }
    /**
     * 下载对应任务的日志;不同任务返回数据类型不同，需要做个表来区分
     */
    @RequestMapping(value = "/getAgentPcap", method = RequestMethod.GET)
    public void getAgentPcap(HttpServletResponse response) throws IOException {
        try {
            byte[] fileBytes = fuzzIntegrationFileApi.getAgentPcap();
            if (fileBytes == null || fileBytes.length == 0) {
                throw new RemoteException("Pcap file is null!");
            }
            Date date = new Date();
            DateFormat df = new SimpleDateFormat("yyyy-MM-dd-hh-mm-ss-");
            kittyAgentService.downloadPcap(df.format(date) + "kitty.pcap", fileBytes, response);
        } catch (Exception e) {
            e.printStackTrace();
            response.sendError(500, "Download failed!");
        }
    }
}
