package com.example.fuzzbackendmaster.controller;


import com.example.fuzzbackendmaster.pojo.vo.AjaxResult;
import com.example.fuzzbackendmaster.service.FuzzIntegrationFileApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * aflnet种子文件
 */
@Slf4j
@RestController
@RequestMapping("/seedFile")
@CrossOrigin
public class SeedFileController {

    @Autowired
    FuzzIntegrationFileApi fuzzIntegrationFileApi;

    /**
     * 种子文件查询接口
     */
    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public AjaxResult list() {

        return fuzzIntegrationFileApi.list();
    }

    /**
     * 种子文件删除接口
     */
    @RequestMapping(value = "/delete/{fileName}", method = RequestMethod.GET)
    public AjaxResult delete(@PathVariable("fileName") String fileName) {
        return fuzzIntegrationFileApi.delFile(fileName);
    }

    /**
     * seeFileUpload
     */
    @RequestMapping(value = "/upload", method = RequestMethod.POST)
    public AjaxResult upload(MultipartFile file) {
        return fuzzIntegrationFileApi.upload(file);
    }
}
