package com.example.fuzzbackendmaster.controller;

import com.example.fuzzbackendmaster.pojo.vo.AjaxResult;
import com.example.fuzzbackendmaster.pojo.vo.CmdStartParams;
import com.example.fuzzbackendmaster.service.FuzzIntegrationFileApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * aflnet测试控制
 */
@Slf4j
@RestController
@RequestMapping("/test")
@CrossOrigin
public class TestController {
    @Autowired
    FuzzIntegrationFileApi fuzzIntegrationFileApi;

    /**
     * 测试启动
     */
    @RequestMapping(value = "/testStart", method = RequestMethod.POST)
    public AjaxResult testStart(@RequestBody final CmdStartParams cmdStartParams) {
        //启动时就开始连接
        fuzzIntegrationFileApi.connect();
        return fuzzIntegrationFileApi.testStart(cmdStartParams);
    }

    /**
     * 测试停止
     */
    @RequestMapping(value = "/testStop", method = RequestMethod.GET)
    public AjaxResult testStop() {
        //停止时就开始关闭
        fuzzIntegrationFileApi.disconnect();
        return fuzzIntegrationFileApi.testStop();
    }

    /**
     * 获取测试信息和测试进度
     */
    @RequestMapping(value = "/testProcessInfo", method = RequestMethod.GET)
    public AjaxResult getTestProcessInfo() {
        //停止时就开始关闭
        return fuzzIntegrationFileApi.getProcessInfo();
    }

    /**
     * 异常重放
     */
    @RequestMapping(value = "/replay", method = RequestMethod.GET)
    public AjaxResult replay(@RequestParam String targetServer, @RequestParam String targetServerCodePath,
                             @RequestParam String targetServerPort, @RequestParam String protocol,
                             @RequestParam String pathToCrash) {
        return fuzzIntegrationFileApi.replay(targetServer, targetServerCodePath,targetServerPort,protocol,pathToCrash);
    }

    /**
     * 异常重放分析
     */
    @RequestMapping(value = "/analyse", method = RequestMethod.GET)
    public AjaxResult analyse(@RequestParam String codePath, @RequestParam String programName) {
        return fuzzIntegrationFileApi.analyse(codePath, programName);
    }

    /**
     * 异常结果获取
     */
    @RequestMapping(value = "/getreplayresult", method = RequestMethod.GET)
    public AjaxResult getReplayResult() {
        return fuzzIntegrationFileApi.getReplayResult();
    }
}